var phasereditor2d;
(function (phasereditor2d) {
    var rive;
    (function (rive) {
        rive.RIVE_CONTENT_TYPE = "phasereditor2d.rive.ContentType";
        rive.ICON_RIVE = "rive";
        class RivePlugin extends colibri.Plugin {
            constructor() {
                super("phasereditor2d.rive");
            }
            static getInstance() {
                return this._instance;
            }
            registerExtensions(reg) {
                // icons loader
                reg.addExtension(colibri.ui.ide.IconLoaderExtension.withPluginFiles(this, [
                    rive.ICON_RIVE
                ]));
                // content type icons
                reg.addExtension(colibri.ui.ide.ContentTypeIconExtension.withPluginIcons(this, [
                    {
                        iconName: rive.ICON_RIVE,
                        contentType: rive.RIVE_CONTENT_TYPE
                    }
                ]));
                // pack extensions
                reg.addExtension(new colibri.core.ContentTypeExtension([
                    new colibri.core.ContentTypeResolverByExtension("phasereditor2d.rive.RiveContentTypeResolver", [
                        ["riv", rive.RIVE_CONTENT_TYPE]
                    ])
                ]));
                reg.addExtension(new rive.pack.RiveAssetPackExtension());
            }
        }
        RivePlugin._instance = new RivePlugin();
        rive.RivePlugin = RivePlugin;
        colibri.Platform.addPlugin(RivePlugin.getInstance());
    })(rive = phasereditor2d.rive || (phasereditor2d.rive = {}));
})(phasereditor2d || (phasereditor2d = {}));
var phasereditor2d;
(function (phasereditor2d) {
    var rive;
    (function (rive) {
        var pack;
        (function (pack_1) {
            pack_1.RIVE_TYPE = "rive";
            class RiveAssetPackExtension extends phasereditor2d.pack.ui.AssetPackExtension {
                createAssetPackItem(type, data, pack) {
                    if (type === pack_1.RIVE_TYPE) {
                        return new pack_1.RiveAssetPackItem(pack, data);
                    }
                    return undefined;
                }
                getAssetPackItemTypes() {
                    return [{ type: pack_1.RIVE_TYPE, displayName: "Rive File" }];
                }
                createImporters() {
                    return [
                        new phasereditor2d.pack.ui.importers.SingleFileImporter(rive.RIVE_CONTENT_TYPE, pack_1.RIVE_TYPE)
                    ];
                }
                getCellRenderer(element, layout) {
                    if (element instanceof pack_1.RiveAssetPackItem) {
                        return phasereditor2d.pack.ui.DefaultAssetPackExtension.getIconRenderer(rive.RivePlugin.getInstance().getIcon(rive.ICON_RIVE), layout);
                    }
                    return undefined;
                }
                createEditorPropertySections(page) {
                    return [
                        new pack_1.RiveAssetPackItemSection(page),
                    ];
                }
            }
            pack_1.RiveAssetPackExtension = RiveAssetPackExtension;
        })(pack = rive.pack || (rive.pack = {}));
    })(rive = phasereditor2d.rive || (phasereditor2d.rive = {}));
})(phasereditor2d || (phasereditor2d = {}));
var phasereditor2d;
(function (phasereditor2d) {
    var rive;
    (function (rive) {
        var pack;
        (function (pack) {
            class RiveAssetPackItem extends phasereditor2d.pack.core.AssetPackItem {
            }
            pack.RiveAssetPackItem = RiveAssetPackItem;
        })(pack = rive.pack || (rive.pack = {}));
    })(rive = phasereditor2d.rive || (phasereditor2d.rive = {}));
})(phasereditor2d || (phasereditor2d = {}));
var phasereditor2d;
(function (phasereditor2d) {
    var rive;
    (function (rive) {
        var pack;
        (function (pack) {
            class RiveAssetPackItemSection extends phasereditor2d.pack.ui.editor.properties.SimpleURLSection {
                constructor(page) {
                    super(page, "phasereditor2d.rive.pack.RiveAssetPackItemSection", "Rive File", "URL", "url", rive.RIVE_CONTENT_TYPE, pack.RIVE_TYPE);
                }
            }
            pack.RiveAssetPackItemSection = RiveAssetPackItemSection;
        })(pack = rive.pack || (rive.pack = {}));
    })(rive = phasereditor2d.rive || (phasereditor2d.rive = {}));
})(phasereditor2d || (phasereditor2d = {}));
